# check-in a file in the RCS directory
# the diff file has the extension _$n where $n is the version number
# options are :
# -i identical
# -h help
# needs UNIX wc patch diff indent in PATH

use Getopt::Std;

my %opt;

sub new_diff {
	$n = `$LS RCS$SEP$_[0]* | wc -l`;
	$n++;
	$n--;
	system("$CP RCS$SEP$_[0]_0 $_[0]_orig");
	foreach $i (`$LS RCS$SEP$_[0]_*`) {
		if ( $i ne "$_[0]_0\n" ) {
			system("patch $_[0]_orig RCS$SEP$i");
		}
	}
	$diff = `diff $_[0]_orig $_[0]`;
	if ( ( $diff eq "" ) and ( !$opt{'i'} ) ) {
		print "identical\n";
	}
	else {
		open( FILE, ">RCS$SEP$_[0]_$n" );
		print FILE $diff;
		close FILE;
	}
	system("$RM $_[0]_orig");
}

sub ci {
	$user = `$CAT RCS${SEP}lock_$_[0]`;
	chomp($user);
	if ( ( $user eq "" ) || ( $user eq $ENV{"USERNAME"} ) ) {
		$ext = substr( $_[0], index( $_[0], "." ) + 1, 3 );
		if ( ( $ext eq "c" ) or ( $ext eq "h" ) ) {
			print("$_[0] is a source file\n");
			system("indent $_[0]");
		}
		if ( $ext eq "pl" )  {
			system("perl -c $_[0]");
		}
		if ( !open( FILE, "RCS$SEP$_[0]_0" ) ) {
			system("$CP $_[0] RCS$SEP$_[0]_0");
			return;
		}
		close FILE;
		new_diff $_[0];
		system("$RM RCS${SEP}lock_$_[0]");
	}
	else {
		print "$user has locked the file";
	}
}

if ($ENV{'OS'} eq "WindowsNT") {
	$LS="dir /b /od";
	$CP="copy";
	$RM="del";
	$CAT="type";
	$SEP="\\";
} elsif ($ENV{'HOSTNAME'} eq "linux") {
	$LS="ls -1 -rt";
	$CP="cp";
	$RM="rm";
	$CAT="cat";
	$SEP="/";
} else {
	die "$ENV{'OS'} systeme non reconnu\n";
}

getopts( 'hi', \%opt );
if ( $opt{'h'} ) {
	print STDERR "usage: ci [-hi] file";
}
else {
	ci $ARGV[0];
}
